"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    collapsibleListUnion: ()=>collapsibleListUnion,
    listUnion: ()=>listUnion
});
const _composeJs = require("../compose.js");
const collapsibleListUnion = (l, r)=>{
    if (Array.isArray(l)) {
        if (Array.isArray(r)) {
            const result = listUnion(l, r);
            return result.length === l.length ? result.length === r.length ? (0, _composeJs.equality)() : l : result.length === r.length ? r : result;
        }
        return l.includes(r) ? l : [
            ...l,
            r
        ];
    }
    if (Array.isArray(r)) {
        return r.includes(l) ? r : [
            ...r,
            l
        ];
    }
    return l === r ? (0, _composeJs.equality)() : [
        l,
        r
    ];
};
const listUnion = (l, r)=>{
    const result = [
        ...l
    ];
    for (const expression of r){
        if (!l.includes(expression)) {
            result.push(expression);
        }
    }
    return result;
};
