"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    getRegex: ()=>getRegex,
    checkRegex: ()=>checkRegex,
    regexIntersection: ()=>regexIntersection
});
const _composeJs = require("../compose.js");
const _collapsibleSetJs = require("./collapsibleSet.js");
const regexCache = {};
const getRegex = (source)=>{
    if (!regexCache[source]) {
        regexCache[source] = new RegExp(source);
    }
    return regexCache[source];
};
const checkRegex = (source, state)=>getRegex(source).test(state.data) || !state.problems.add("regex", `/${source}/`);
const regexIntersection = (0, _composeJs.composeIntersection)(_collapsibleSetJs.collapsibleListUnion);
