"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    compileDisjointReasonsMessage: ()=>compileDisjointReasonsMessage,
    writeImplicitNeverMessage: ()=>writeImplicitNeverMessage
});
const _composeJs = require("../../nodes/compose.js");
const _genericsJs = require("../../utils/generics.js");
const compileDisjointReasonsMessage = (disjoints)=>{
    const paths = (0, _genericsJs.objectKeysOf)(disjoints);
    if (paths.length === 1) {
        const path = paths[0];
        return `${path === "/" ? "" : `At ${path}: `}Intersection of ${_composeJs.disjointDescriptionWriters[disjoints[path].kind](disjoints[path])} results in an unsatisfiable type`;
    }
    let message = `
        "Intersection results in unsatisfiable types at the following paths:\n`;
    for(const path in disjoints){
        message += `  ${path}: ${_composeJs.disjointDescriptionWriters[disjoints[path].kind](disjoints[path])}\n`;
    }
    return message;
};
const writeImplicitNeverMessage = (path, operator, description)=>`${path.length ? `At ${path}: ` : ""}${operator} ${description ? `${description} ` : ""}results in an unsatisfiable type`;
