"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    Path: ()=>Path,
    getPath: ()=>getPath
});
class Path extends Array {
    static fromString(s, delimiter = "/") {
        return s === delimiter ? new Path() : new Path(...s.split(delimiter));
    }
    toString(delimiter = "/") {
        return this.length ? this.join(delimiter) : delimiter;
    }
}
const getPath = (root, path)=>{
    let result = root;
    for (const segment of path){
        if (typeof result !== "object" || result === null) {
            return undefined;
        }
        result = result[segment];
    }
    return result;
};
