import { objectKindOf } from "../../utils/objectKinds.js";
import { composeIntersection, equality } from "../compose.js";
export const classIntersection = composeIntersection((l, r, state)=>{
    return l === r ? equality() : l instanceof r ? l : r instanceof l ? r : state.addDisjoint("class", l, r);
});
export const checkClass = (expectedClass, state)=>{
    if (typeof expectedClass === "string") {
        return objectKindOf(state.data) === expectedClass || !state.problems.add("class", expectedClass);
    }
    return state.data instanceof expectedClass || !state.problems.add("class", expectedClass);
};
