import { composeIntersection } from "../compose.js";
import { collapsibleListUnion } from "./collapsibleSet.js";
const regexCache = {};
export const getRegex = (source)=>{
    if (!regexCache[source]) {
        regexCache[source] = new RegExp(source);
    }
    return regexCache[source];
};
export const checkRegex = (source, state)=>getRegex(source).test(state.data) || !state.problems.add("regex", `/${source}/`);
export const regexIntersection = composeIntersection(collapsibleListUnion);
