import { disjointDescriptionWriters } from "../../nodes/compose.js";
import { objectKeysOf } from "../../utils/generics.js";
export const compileDisjointReasonsMessage = (disjoints)=>{
    const paths = objectKeysOf(disjoints);
    if (paths.length === 1) {
        const path = paths[0];
        return `${path === "/" ? "" : `At ${path}: `}Intersection of ${disjointDescriptionWriters[disjoints[path].kind](disjoints[path])} results in an unsatisfiable type`;
    }
    let message = `
        "Intersection results in unsatisfiable types at the following paths:\n`;
    for(const path in disjoints){
        message += `  ${path}: ${disjointDescriptionWriters[disjoints[path].kind](disjoints[path])}\n`;
    }
    return message;
};
export const writeImplicitNeverMessage = (path, operator, description)=>`${path.length ? `At ${path}: ` : ""}${operator} ${description ? `${description} ` : ""}results in an unsatisfiable type`;
