import { parseDefinition } from "./definition.js";
import { Scanner } from "./string/shift/scanner.js";
export const parseRecord = (def, ctx)=>{
    const props = {};
    for(const definitionKey in def){
        let keyName = definitionKey;
        let isOptional = false;
        if (definitionKey[definitionKey.length - 1] === "?") {
            if (definitionKey[definitionKey.length - 2] === Scanner.escapeToken) {
                keyName = `${definitionKey.slice(0, -2)}?`;
            } else {
                keyName = definitionKey.slice(0, -1);
                isOptional = true;
            }
        }
        ctx.path.push(keyName);
        const propNode = parseDefinition(def[definitionKey], ctx);
        ctx.path.pop();
        props[keyName] = isOptional ? [
            "?",
            propNode
        ] : propNode;
    }
    return {
        object: {
            props
        }
    };
};
