function _defineProperty(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
import { deepFreeze } from "../utils/freeze.js";
export class Cache {
    get root() {
        return this.cache;
    }
    has(name) {
        return name in this.cache;
    }
    get(name) {
        return this.cache[name];
    }
    set(name, item) {
        this.cache[name] = item;
        return item;
    }
    constructor(){
        _defineProperty(this, "cache", {});
    }
}
export class FreezingCache extends Cache {
    set(name, item) {
        this.cache[name] = deepFreeze(item);
        return item;
    }
}
