export class Path extends Array {
    static fromString(s, delimiter = "/") {
        return s === delimiter ? new Path() : new Path(...s.split(delimiter));
    }
    toString(delimiter = "/") {
        return this.length ? this.join(delimiter) : delimiter;
    }
}
export const getPath = (root, path)=>{
    let result = root;
    for (const segment of path){
        if (typeof result !== "object" || result === null) {
            return undefined;
        }
        result = result[segment];
    }
    return result;
};
