import type { DisjointsByPath } from "../../nodes/compose.js";
import type { MappedKeys } from "../../nodes/rules/props.js";
import type { asConst, Dict, error, evaluate, extractValues, isAny, List, stringKeyOf, tryCatch } from "../../utils/generics.js";
import type { Path, pathToString } from "../../utils/paths.js";
import type { ParsedMorph } from "./morph.js";
export type inferIntersection<l, r> = inferIntersectionRecurse<l, r, []>;
type inferIntersectionRecurse<l, r, path extends string[]> = path["length"] extends 10 ? l & r : l extends never ? never : r extends never ? never : l & r extends never ? error<writeImplicitNeverMessage<path, "Intersection">> : isAny<l | r> extends true ? any : l extends ParsedMorph<infer lIn, infer lOut> ? r extends ParsedMorph ? error<writeImplicitNeverMessage<path, "Intersection", "of morphs">> : (In: evaluate<lIn & r>) => lOut : r extends ParsedMorph<infer rIn, infer rOut> ? (In: evaluate<rIn & l>) => rOut : [l, r] extends [Dict, Dict] ? bubblePropErrors<evaluate<{
    [k in stringKeyOf<l>]: k extends keyof r ? inferIntersectionRecurse<l[k], r[k], [...path, k]> : l[k];
} & Omit<r, keyof l>>> : l extends List ? r extends List ? inferArrayIntersection<l, r, path> : l & r : l & r;
type inferArrayIntersection<l extends List, r extends List, path extends string[]> = isTuple<l> extends true ? {
    [i in keyof l]: inferIntersectionRecurse<l[i], r[i & keyof r], [
        ...path,
        `${i}`
    ]> extends infer result ? tryCatch<result, result> : never;
} : isTuple<r> extends true ? {
    [i in keyof r]: inferIntersectionRecurse<l[i & keyof l], r[i], [
        ...path,
        `${i}`
    ]> extends infer result ? tryCatch<result, result> : never;
} : inferIntersectionRecurse<l[number], r[number], [
    ...path,
    MappedKeys["index"]
]> extends infer result ? tryCatch<result, result[]> : never;
type isTuple<list extends List> = number extends list["length"] ? false : true;
type bubblePropErrors<o> = extractValues<o, error> extends never ? o : extractValues<o, error>;
export declare const compileDisjointReasonsMessage: (disjoints: DisjointsByPath) => string;
export declare const writeImplicitNeverMessage: <path extends [] | Path, operator extends "keyof" | "Intersection", description extends string = "">(path: asConst<path>, operator: operator, description?: description | undefined) => `${path extends [] ? "" : `At ${pathToString<path, "/">}: `}${operator} ${description extends "" ? "" : `${description} `}results in an unsatisfiable type`;
export type writeImplicitNeverMessage<path extends string[], operator extends "Intersection" | "keyof", description extends string = ""> = `${path extends [] ? "" : `At ${pathToString<path>}: `}${operator} ${description extends "" ? "" : `${description} `}results in an unsatisfiable type`;
export {};
